/**
 */
package org.fortiss.af3.exploration.moea.model.predefined.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.fortiss.af3.component.model.Component;

import org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression;
import org.fortiss.af3.exploration.dsl.model.ModelPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.Expression;

import org.fortiss.af3.exploration.model.CommonPackage;
import org.fortiss.af3.exploration.model.ExplorationObjective;
import org.fortiss.af3.exploration.model.ExplorationTarget;
import org.fortiss.af3.exploration.model.MOExplorationObjective;

import org.fortiss.af3.exploration.moea.model.predefined.FailureMinObjective;
import org.fortiss.af3.exploration.moea.model.predefined.FailureMode;
import org.fortiss.af3.exploration.moea.model.predefined.FailureType;
import org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Failure Min Objective</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.FailureMinObjectiveImpl#getId <em>Id</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.FailureMinObjectiveImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.FailureMinObjectiveImpl#getComment <em>Comment</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.FailureMinObjectiveImpl#getExpression <em>Expression</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.FailureMinObjectiveImpl#getPriority <em>Priority</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.FailureMinObjectiveImpl#getMode <em>Mode</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.FailureMinObjectiveImpl#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FailureMinObjectiveImpl extends EObjectImpl implements FailureMinObjective {
	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final int ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected int id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getComment() <em>Comment</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComment()
	 * @generated
	 * @ordered
	 */
	protected static final String COMMENT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getComment() <em>Comment</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComment()
	 * @generated
	 * @ordered
	 */
	protected String comment = COMMENT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExpression() <em>Expression</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExpression()
	 * @generated
	 * @ordered
	 */
	protected Expression expression;

	/**
	 * The default value of the '{@link #getPriority() <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected static final int PRIORITY_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getPriority() <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected int priority = PRIORITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getMode() <em>Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMode()
	 * @generated
	 * @ordered
	 */
	protected static final FailureMode MODE_EDEFAULT = FailureMode.FAIL_SAFE;

	/**
	 * The cached value of the '{@link #getMode() <em>Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMode()
	 * @generated
	 * @ordered
	 */
	protected FailureMode mode = MODE_EDEFAULT;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final FailureType TYPE_EDEFAULT = FailureType.DUF;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected FailureType type = TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FailureMinObjectiveImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PredefinedPackage.Literals.FAILURE_MIN_OBJECTIVE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(int newId) {
		int oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.FAILURE_MIN_OBJECTIVE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.FAILURE_MIN_OBJECTIVE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getComment() {
		return comment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setComment(String newComment) {
		String oldComment = comment;
		comment = newComment;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.FAILURE_MIN_OBJECTIVE__COMMENT, oldComment, comment));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression getExpression() {
		if (expression != null && expression.eIsProxy()) {
			InternalEObject oldExpression = (InternalEObject)expression;
			expression = (Expression)eResolveProxy(oldExpression);
			if (expression != oldExpression) {
				InternalEObject newExpression = (InternalEObject)expression;
				NotificationChain msgs = oldExpression.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION, null, null);
				if (newExpression.eInternalContainer() == null) {
					msgs = newExpression.eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION, null, msgs);
				}
				if (msgs != null) msgs.dispatch();
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION, oldExpression, expression));
			}
		}
		return expression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression basicGetExpression() {
		return expression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExpression(Expression newExpression, NotificationChain msgs) {
		Expression oldExpression = expression;
		expression = newExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION, oldExpression, newExpression);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExpression(Expression newExpression) {
		if (newExpression != expression) {
			NotificationChain msgs = null;
			if (expression != null)
				msgs = ((InternalEObject)expression).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION, null, msgs);
			if (newExpression != null)
				msgs = ((InternalEObject)newExpression).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION, null, msgs);
			msgs = basicSetExpression(newExpression, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION, newExpression, newExpression));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPriority() {
		return priority;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPriority(int newPriority) {
		int oldPriority = priority;
		priority = newPriority;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.FAILURE_MIN_OBJECTIVE__PRIORITY, oldPriority, priority));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FailureMode getMode() {
		return mode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMode(FailureMode newMode) {
		FailureMode oldMode = mode;
		mode = newMode == null ? MODE_EDEFAULT : newMode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.FAILURE_MIN_OBJECTIVE__MODE, oldMode, mode));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FailureType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(FailureType newType) {
		FailureType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.FAILURE_MIN_OBJECTIVE__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Component getTargetComponent() {
		return FailureMinObjectiveStaticImpl.getFailureMinTargetComponent(this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTargetComponent(final Component targetComponent) {
		FailureMinObjectiveStaticImpl.setFailureMinTargetComponent(this, targetComponent);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION:
				return basicSetExpression(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__ID:
				return getId();
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__NAME:
				return getName();
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__COMMENT:
				return getComment();
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION:
				if (resolve) return getExpression();
				return basicGetExpression();
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__PRIORITY:
				return getPriority();
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__MODE:
				return getMode();
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__TYPE:
				return getType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__ID:
				setId((Integer)newValue);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__NAME:
				setName((String)newValue);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__COMMENT:
				setComment((String)newValue);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION:
				setExpression((Expression)newValue);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__PRIORITY:
				setPriority((Integer)newValue);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__MODE:
				setMode((FailureMode)newValue);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__TYPE:
				setType((FailureType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__ID:
				setId(ID_EDEFAULT);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__COMMENT:
				setComment(COMMENT_EDEFAULT);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION:
				setExpression((Expression)null);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__PRIORITY:
				setPriority(PRIORITY_EDEFAULT);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__MODE:
				setMode(MODE_EDEFAULT);
				return;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__TYPE:
				setType(TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__ID:
				return id != ID_EDEFAULT;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__COMMENT:
				return COMMENT_EDEFAULT == null ? comment != null : !COMMENT_EDEFAULT.equals(comment);
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION:
				return expression != null;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__PRIORITY:
				return priority != PRIORITY_EDEFAULT;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__MODE:
				return mode != MODE_EDEFAULT;
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE__TYPE:
				return type != TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MOEAExplorationExpression.class) {
			switch (derivedFeatureID) {
				case PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION: return ModelPackage.MOEA_EXPLORATION_EXPRESSION__EXPRESSION;
				default: return -1;
			}
		}
		if (baseClass == ExplorationTarget.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ExplorationObjective.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == MOExplorationObjective.class) {
			switch (derivedFeatureID) {
				case PredefinedPackage.FAILURE_MIN_OBJECTIVE__PRIORITY: return CommonPackage.MO_EXPLORATION_OBJECTIVE__PRIORITY;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MOEAExplorationExpression.class) {
			switch (baseFeatureID) {
				case ModelPackage.MOEA_EXPLORATION_EXPRESSION__EXPRESSION: return PredefinedPackage.FAILURE_MIN_OBJECTIVE__EXPRESSION;
				default: return -1;
			}
		}
		if (baseClass == ExplorationTarget.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == ExplorationObjective.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == MOExplorationObjective.class) {
			switch (baseFeatureID) {
				case CommonPackage.MO_EXPLORATION_OBJECTIVE__PRIORITY: return PredefinedPackage.FAILURE_MIN_OBJECTIVE__PRIORITY;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: ");
		result.append(id);
		result.append(", name: ");
		result.append(name);
		result.append(", comment: ");
		result.append(comment);
		result.append(", priority: ");
		result.append(priority);
		result.append(", mode: ");
		result.append(mode);
		result.append(", type: ");
		result.append(type);
		result.append(')');
		return result.toString();
	}

} //FailureMinObjectiveImpl
