/**
 */
package org.fortiss.af3.exploration.moea.model.predefined.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.fortiss.af3.component.model.Component;

import org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression;
import org.fortiss.af3.exploration.dsl.model.ModelPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.Expression;

import org.fortiss.af3.exploration.model.IProblemDimension;
import org.fortiss.af3.exploration.model.SafetyDimension;

import org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage;
import org.fortiss.af3.exploration.moea.model.predefined.SafetyIntegrityLevelConstraint;

import org.fortiss.af3.safety.model.SIL;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Safety Integrity Level Constraint</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.SafetyIntegrityLevelConstraintImpl#getId <em>Id</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.SafetyIntegrityLevelConstraintImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.SafetyIntegrityLevelConstraintImpl#getComment <em>Comment</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.SafetyIntegrityLevelConstraintImpl#isIsSoft <em>Is Soft</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.SafetyIntegrityLevelConstraintImpl#isImplicit <em>Implicit</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.SafetyIntegrityLevelConstraintImpl#getExpression <em>Expression</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.impl.SafetyIntegrityLevelConstraintImpl#getComponents <em>Components</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SafetyIntegrityLevelConstraintImpl extends EObjectImpl implements SafetyIntegrityLevelConstraint {
	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final int ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected int id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getComment() <em>Comment</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComment()
	 * @generated
	 * @ordered
	 */
	protected static final String COMMENT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getComment() <em>Comment</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComment()
	 * @generated
	 * @ordered
	 */
	protected String comment = COMMENT_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsSoft() <em>Is Soft</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsSoft()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_SOFT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsSoft() <em>Is Soft</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsSoft()
	 * @generated
	 * @ordered
	 */
	protected boolean isSoft = IS_SOFT_EDEFAULT;

	/**
	 * The default value of the '{@link #isImplicit() <em>Implicit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isImplicit()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IMPLICIT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isImplicit() <em>Implicit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isImplicit()
	 * @generated
	 * @ordered
	 */
	protected boolean implicit = IMPLICIT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExpression() <em>Expression</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExpression()
	 * @generated
	 * @ordered
	 */
	protected Expression expression;

	/**
	 * The cached value of the '{@link #getComponents() <em>Components</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponents()
	 * @generated
	 * @ordered
	 */
	protected EList<Component> components;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SafetyIntegrityLevelConstraintImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PredefinedPackage.Literals.SAFETY_INTEGRITY_LEVEL_CONSTRAINT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(int newId) {
		int oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getComment() {
		return comment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setComment(String newComment) {
		String oldComment = comment;
		comment = newComment;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMMENT, oldComment, comment));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsSoft() {
		return isSoft;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsSoft(boolean newIsSoft) {
		boolean oldIsSoft = isSoft;
		isSoft = newIsSoft;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IS_SOFT, oldIsSoft, isSoft));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isImplicit() {
		return implicit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setImplicit(boolean newImplicit) {
		boolean oldImplicit = implicit;
		implicit = newImplicit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IMPLICIT, oldImplicit, implicit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression getExpression() {
		if (expression != null && expression.eIsProxy()) {
			InternalEObject oldExpression = (InternalEObject)expression;
			expression = (Expression)eResolveProxy(oldExpression);
			if (expression != oldExpression) {
				InternalEObject newExpression = (InternalEObject)expression;
				NotificationChain msgs = oldExpression.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION, null, null);
				if (newExpression.eInternalContainer() == null) {
					msgs = newExpression.eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION, null, msgs);
				}
				if (msgs != null) msgs.dispatch();
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION, oldExpression, expression));
			}
		}
		return expression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression basicGetExpression() {
		return expression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExpression(Expression newExpression, NotificationChain msgs) {
		Expression oldExpression = expression;
		expression = newExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION, oldExpression, newExpression);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExpression(Expression newExpression) {
		if (newExpression != expression) {
			NotificationChain msgs = null;
			if (expression != null)
				msgs = ((InternalEObject)expression).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION, null, msgs);
			if (newExpression != null)
				msgs = ((InternalEObject)newExpression).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION, null, msgs);
			msgs = basicSetExpression(newExpression, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION, newExpression, newExpression));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Component> getComponents() {
		if (components == null) {
			components = new EObjectResolvingEList<Component>(Component.class, this, PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMPONENTS);
		}
		return components;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SIL> getLimitation() {
		return SafetyIntegrityLevelConstraintStaticImpl.getLimitation(this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION:
				return basicSetExpression(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__ID:
				return getId();
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__NAME:
				return getName();
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMMENT:
				return getComment();
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IS_SOFT:
				return isIsSoft();
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IMPLICIT:
				return isImplicit();
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION:
				if (resolve) return getExpression();
				return basicGetExpression();
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMPONENTS:
				return getComponents();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__ID:
				setId((Integer)newValue);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__NAME:
				setName((String)newValue);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMMENT:
				setComment((String)newValue);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IS_SOFT:
				setIsSoft((Boolean)newValue);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IMPLICIT:
				setImplicit((Boolean)newValue);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION:
				setExpression((Expression)newValue);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMPONENTS:
				getComponents().clear();
				getComponents().addAll((Collection<? extends Component>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__ID:
				setId(ID_EDEFAULT);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMMENT:
				setComment(COMMENT_EDEFAULT);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IS_SOFT:
				setIsSoft(IS_SOFT_EDEFAULT);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IMPLICIT:
				setImplicit(IMPLICIT_EDEFAULT);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION:
				setExpression((Expression)null);
				return;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMPONENTS:
				getComponents().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__ID:
				return id != ID_EDEFAULT;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMMENT:
				return COMMENT_EDEFAULT == null ? comment != null : !COMMENT_EDEFAULT.equals(comment);
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IS_SOFT:
				return isSoft != IS_SOFT_EDEFAULT;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__IMPLICIT:
				return implicit != IMPLICIT_EDEFAULT;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION:
				return expression != null;
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMPONENTS:
				return components != null && !components.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == IProblemDimension.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == SafetyDimension.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == MOEAExplorationExpression.class) {
			switch (derivedFeatureID) {
				case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION: return ModelPackage.MOEA_EXPLORATION_EXPRESSION__EXPRESSION;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == IProblemDimension.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == SafetyDimension.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		if (baseClass == MOEAExplorationExpression.class) {
			switch (baseFeatureID) {
				case ModelPackage.MOEA_EXPLORATION_EXPRESSION__EXPRESSION: return PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT__EXPRESSION;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: ");
		result.append(id);
		result.append(", name: ");
		result.append(name);
		result.append(", comment: ");
		result.append(comment);
		result.append(", isSoft: ");
		result.append(isSoft);
		result.append(", implicit: ");
		result.append(implicit);
		result.append(')');
		return result.toString();
	}

} //SafetyIntegrityLevelConstraintImpl
