/*--------------------------------------------------------------------------+
$Id: ArchExpSubEncoding.java 3032 2016-06-16 18:13:12Z diewald $
|                                                                          |
| Copyright 2015 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.genotype.ComposableGenotype;

/**
 * Marker interface for encodings of sub problems of an architectural exploration problem solved by
 * the DSE. All sub encodings must inherit from this interface to be properly recognized.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3032 $
 * @ConQAT.Rating RED Hash: 5689F53CFA04401B588CA43875D062C7
 */

public interface ArchExpSubEncoding extends ComposableGenotype {
	// TODO: Check whether this interface can be removed.
	// Marker interface.
}
