/*--------------------------------------------------------------------------+
$Id: AF3PlatformArchitectureAdapter.java 3038 2016-06-17 13:26:28Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.sysmodel.arch.af3;

import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IPlatformArchitectureAdapter;
import org.fortiss.af3.platform.model.PlatformArchitecture;

/**
 * Abstracts an input platform architecture, i.e. a {@link PlatformArchitecture}.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3038 $
 * @ConQAT.Rating YELLOW Hash: 36418DE9FA7E3F0396A951F123076788
 */
public class AF3PlatformArchitectureAdapter extends AF3ModelElementAdapter<PlatformArchitecture>
		implements IPlatformArchitectureAdapter<PlatformArchitecture> {

	/** Constructor. */
	public AF3PlatformArchitectureAdapter(PlatformArchitecture platformArchitecture) {
		super(platformArchitecture);
	}
}
