/**
 */
package org.fortiss.af3.exploration.dsl.model.operators.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.ETypeParameter;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.fortiss.af3.exploration.dsl.model.ModelPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.ExpressionsPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.impl.ExpressionsPackageImpl;

import org.fortiss.af3.exploration.dsl.model.impl.ModelPackageImpl;

import org.fortiss.af3.exploration.dsl.model.operators.ArithmeticOp;
import org.fortiss.af3.exploration.dsl.model.operators.ArithmeticOperatorEnum;
import org.fortiss.af3.exploration.dsl.model.operators.BooleanOperatorEnum;
import org.fortiss.af3.exploration.dsl.model.operators.ComparisonOp;
import org.fortiss.af3.exploration.dsl.model.operators.ComparisonOperatorEnum;
import org.fortiss.af3.exploration.dsl.model.operators.DualOperator;
import org.fortiss.af3.exploration.dsl.model.operators.LocationOp;
import org.fortiss.af3.exploration.dsl.model.operators.LocationOperatorEnum;
import org.fortiss.af3.exploration.dsl.model.operators.Operator;
import org.fortiss.af3.exploration.dsl.model.operators.OperatorsFactory;
import org.fortiss.af3.exploration.dsl.model.operators.OperatorsPackage;
import org.fortiss.af3.exploration.dsl.model.operators.OptimizationDirection;
import org.fortiss.af3.exploration.dsl.model.operators.OptimizationDirectionEnum;
import org.fortiss.af3.exploration.dsl.model.operators.QuantifierEnum;
import org.fortiss.af3.exploration.dsl.model.operators.QuantifierOp;
import org.fortiss.af3.exploration.dsl.model.operators.SummationOp;

import org.fortiss.af3.exploration.dsl.model.patterns.PatternsPackage;

import org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl;

import org.fortiss.af3.exploration.dsl.model.types.TypesPackage;

import org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl;

import org.fortiss.tooling.base.model.base.BasePackage;

import org.fortiss.tooling.base.model.element.ElementPackage;

import org.fortiss.tooling.base.model.layout.LayoutPackage;

import org.fortiss.tooling.base.model.visualization.VisualizationPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class OperatorsPackageImpl extends EPackageImpl implements OperatorsPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass operatorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dualOperatorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass arithmeticOpEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass comparisonOpEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass locationOpEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass optimizationDirectionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass quantifierOpEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass summationOpEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum arithmeticOperatorEnumEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum booleanOperatorEnumEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum comparisonOperatorEnumEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum locationOperatorEnumEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum optimizationDirectionEnumEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum quantifierEnumEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.fortiss.af3.exploration.dsl.model.operators.OperatorsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private OperatorsPackageImpl() {
		super(eNS_URI, OperatorsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link OperatorsPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static OperatorsPackage init() {
		if (isInited) return (OperatorsPackage)EPackage.Registry.INSTANCE.getEPackage(OperatorsPackage.eNS_URI);

		// Obtain or create and register package
		OperatorsPackageImpl theOperatorsPackage = (OperatorsPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof OperatorsPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new OperatorsPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		ElementPackage.eINSTANCE.eClass();
		LayoutPackage.eINSTANCE.eClass();
		BasePackage.eINSTANCE.eClass();
		VisualizationPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		ModelPackageImpl theModelPackage = (ModelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) instanceof ModelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) : ModelPackage.eINSTANCE);
		ExpressionsPackageImpl theExpressionsPackage = (ExpressionsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI) instanceof ExpressionsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI) : ExpressionsPackage.eINSTANCE);
		PatternsPackageImpl thePatternsPackage = (PatternsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PatternsPackage.eNS_URI) instanceof PatternsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PatternsPackage.eNS_URI) : PatternsPackage.eINSTANCE);
		TypesPackageImpl theTypesPackage = (TypesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TypesPackage.eNS_URI) instanceof TypesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TypesPackage.eNS_URI) : TypesPackage.eINSTANCE);

		// Create package meta-data objects
		theOperatorsPackage.createPackageContents();
		theModelPackage.createPackageContents();
		theExpressionsPackage.createPackageContents();
		thePatternsPackage.createPackageContents();
		theTypesPackage.createPackageContents();

		// Initialize created meta-data
		theOperatorsPackage.initializePackageContents();
		theModelPackage.initializePackageContents();
		theExpressionsPackage.initializePackageContents();
		thePatternsPackage.initializePackageContents();
		theTypesPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theOperatorsPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(OperatorsPackage.eNS_URI, theOperatorsPackage);
		return theOperatorsPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOperator() {
		return operatorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOperator_Operator() {
		return (EAttribute)operatorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getOperator_Right() {
		return (EReference)operatorEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDualOperator() {
		return dualOperatorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDualOperator_Left() {
		return (EReference)dualOperatorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getArithmeticOp() {
		return arithmeticOpEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComparisonOp() {
		return comparisonOpEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLocationOp() {
		return locationOpEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOptimizationDirection() {
		return optimizationDirectionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getQuantifierOp() {
		return quantifierOpEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSummationOp() {
		return summationOpEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getArithmeticOperatorEnum() {
		return arithmeticOperatorEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getBooleanOperatorEnum() {
		return booleanOperatorEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getComparisonOperatorEnum() {
		return comparisonOperatorEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getLocationOperatorEnum() {
		return locationOperatorEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getOptimizationDirectionEnum() {
		return optimizationDirectionEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getQuantifierEnum() {
		return quantifierEnumEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OperatorsFactory getOperatorsFactory() {
		return (OperatorsFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		operatorEClass = createEClass(OPERATOR);
		createEAttribute(operatorEClass, OPERATOR__OPERATOR);
		createEReference(operatorEClass, OPERATOR__RIGHT);

		dualOperatorEClass = createEClass(DUAL_OPERATOR);
		createEReference(dualOperatorEClass, DUAL_OPERATOR__LEFT);

		arithmeticOpEClass = createEClass(ARITHMETIC_OP);

		comparisonOpEClass = createEClass(COMPARISON_OP);

		locationOpEClass = createEClass(LOCATION_OP);

		optimizationDirectionEClass = createEClass(OPTIMIZATION_DIRECTION);

		quantifierOpEClass = createEClass(QUANTIFIER_OP);

		summationOpEClass = createEClass(SUMMATION_OP);

		// Create enums
		arithmeticOperatorEnumEEnum = createEEnum(ARITHMETIC_OPERATOR_ENUM);
		booleanOperatorEnumEEnum = createEEnum(BOOLEAN_OPERATOR_ENUM);
		comparisonOperatorEnumEEnum = createEEnum(COMPARISON_OPERATOR_ENUM);
		locationOperatorEnumEEnum = createEEnum(LOCATION_OPERATOR_ENUM);
		optimizationDirectionEnumEEnum = createEEnum(OPTIMIZATION_DIRECTION_ENUM);
		quantifierEnumEEnum = createEEnum(QUANTIFIER_ENUM);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		ExpressionsPackage theExpressionsPackage = (ExpressionsPackage)EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI);
		ElementPackage theElementPackage = (ElementPackage)EPackage.Registry.INSTANCE.getEPackage(ElementPackage.eNS_URI);
		TypesPackage theTypesPackage = (TypesPackage)EPackage.Registry.INSTANCE.getEPackage(TypesPackage.eNS_URI);

		// Create type parameters
		ETypeParameter operatorEClass_OP = addETypeParameter(operatorEClass, "OP");
		ETypeParameter operatorEClass_RHT = addETypeParameter(operatorEClass, "RHT");
		ETypeParameter dualOperatorEClass_LHT = addETypeParameter(dualOperatorEClass, "LHT");
		ETypeParameter dualOperatorEClass_OP = addETypeParameter(dualOperatorEClass, "OP");
		ETypeParameter dualOperatorEClass_RHT = addETypeParameter(dualOperatorEClass, "RHT");
		ETypeParameter arithmeticOpEClass_T = addETypeParameter(arithmeticOpEClass, "T");
		ETypeParameter arithmeticOpEClass_LHE = addETypeParameter(arithmeticOpEClass, "LHE");
		ETypeParameter arithmeticOpEClass_RHE = addETypeParameter(arithmeticOpEClass, "RHE");
		ETypeParameter comparisonOpEClass_T = addETypeParameter(comparisonOpEClass, "T");
		ETypeParameter comparisonOpEClass_LHT = addETypeParameter(comparisonOpEClass, "LHT");
		ETypeParameter comparisonOpEClass_RHT = addETypeParameter(comparisonOpEClass, "RHT");
		ETypeParameter locationOpEClass_LHT = addETypeParameter(locationOpEClass, "LHT");
		ETypeParameter locationOpEClass_RHT = addETypeParameter(locationOpEClass, "RHT");
		ETypeParameter summationOpEClass_T = addETypeParameter(summationOpEClass, "T");

		// Set bounds for type parameters
		EGenericType g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		EGenericType g2 = createEGenericType(arithmeticOpEClass_T);
		g1.getETypeArguments().add(g2);
		arithmeticOpEClass_LHE.getEBounds().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g2 = createEGenericType(arithmeticOpEClass_T);
		g1.getETypeArguments().add(g2);
		arithmeticOpEClass_RHE.getEBounds().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g2 = createEGenericType(comparisonOpEClass_T);
		g1.getETypeArguments().add(g2);
		comparisonOpEClass_LHT.getEBounds().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g2 = createEGenericType(comparisonOpEClass_T);
		g1.getETypeArguments().add(g2);
		comparisonOpEClass_RHT.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		locationOpEClass_LHT.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		locationOpEClass_RHT.getEBounds().add(g1);

		// Add supertypes to classes
		g1 = createEGenericType(this.getOperator());
		g2 = createEGenericType(dualOperatorEClass_OP);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(dualOperatorEClass_RHT);
		g1.getETypeArguments().add(g2);
		dualOperatorEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getDualOperator());
		g2 = createEGenericType(arithmeticOpEClass_LHE);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(this.getArithmeticOperatorEnum());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(arithmeticOpEClass_RHE);
		g1.getETypeArguments().add(g2);
		arithmeticOpEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g2 = createEGenericType(arithmeticOpEClass_T);
		g1.getETypeArguments().add(g2);
		arithmeticOpEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getDualOperator());
		g2 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g1.getETypeArguments().add(g2);
		EGenericType g3 = createEGenericType(comparisonOpEClass_T);
		g2.getETypeArguments().add(g3);
		g2 = createEGenericType(this.getComparisonOperatorEnum());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(comparisonOpEClass_T);
		g2.getETypeArguments().add(g3);
		comparisonOpEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getBooleanExpression());
		comparisonOpEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getDualOperator());
		g2 = createEGenericType(theExpressionsPackage.getElementExpression());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(locationOpEClass_LHT);
		g2.getETypeArguments().add(g3);
		g2 = createEGenericType(this.getLocationOperatorEnum());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theExpressionsPackage.getElementExpression());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(locationOpEClass_RHT);
		g2.getETypeArguments().add(g3);
		locationOpEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getBooleanExpression());
		locationOpEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getOperator());
		g2 = createEGenericType(this.getOptimizationDirectionEnum());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType();
		g2.getETypeArguments().add(g3);
		optimizationDirectionEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getOperator());
		g2 = createEGenericType(this.getQuantifierEnum());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theTypesPackage.getSetType());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType();
		g2.getETypeArguments().add(g3);
		quantifierOpEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getOperator());
		g2 = createEGenericType(this.getArithmeticOperatorEnum());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(summationOpEClass_T);
		g2.getETypeArguments().add(g3);
		summationOpEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g2 = createEGenericType(summationOpEClass_T);
		g1.getETypeArguments().add(g2);
		summationOpEClass.getEGenericSuperTypes().add(g1);

		// Initialize classes and features; add operations and parameters
		initEClass(operatorEClass, Operator.class, "Operator", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(operatorEClass_OP);
		initEAttribute(getOperator_Operator(), g1, "operator", null, 1, 1, Operator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(operatorEClass_RHT);
		initEReference(getOperator_Right(), g1, null, "right", null, 1, 1, Operator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dualOperatorEClass, DualOperator.class, "DualOperator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(dualOperatorEClass_LHT);
		initEReference(getDualOperator_Left(), g1, null, "left", null, 1, 1, DualOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(arithmeticOpEClass, ArithmeticOp.class, "ArithmeticOp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(comparisonOpEClass, ComparisonOp.class, "ComparisonOp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(locationOpEClass, LocationOp.class, "LocationOp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(optimizationDirectionEClass, OptimizationDirection.class, "OptimizationDirection", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(quantifierOpEClass, QuantifierOp.class, "QuantifierOp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(summationOpEClass, SummationOp.class, "SummationOp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Initialize enums and add enum literals
		initEEnum(arithmeticOperatorEnumEEnum, ArithmeticOperatorEnum.class, "ArithmeticOperatorEnum");
		addEEnumLiteral(arithmeticOperatorEnumEEnum, ArithmeticOperatorEnum.ADD);
		addEEnumLiteral(arithmeticOperatorEnumEEnum, ArithmeticOperatorEnum.SUB);
		addEEnumLiteral(arithmeticOperatorEnumEEnum, ArithmeticOperatorEnum.MUL);
		addEEnumLiteral(arithmeticOperatorEnumEEnum, ArithmeticOperatorEnum.DIV);

		initEEnum(booleanOperatorEnumEEnum, BooleanOperatorEnum.class, "BooleanOperatorEnum");
		addEEnumLiteral(booleanOperatorEnumEEnum, BooleanOperatorEnum.NOT);
		addEEnumLiteral(booleanOperatorEnumEEnum, BooleanOperatorEnum.AND);
		addEEnumLiteral(booleanOperatorEnumEEnum, BooleanOperatorEnum.OR);
		addEEnumLiteral(booleanOperatorEnumEEnum, BooleanOperatorEnum.XOR);

		initEEnum(comparisonOperatorEnumEEnum, ComparisonOperatorEnum.class, "ComparisonOperatorEnum");
		addEEnumLiteral(comparisonOperatorEnumEEnum, ComparisonOperatorEnum.LESS);
		addEEnumLiteral(comparisonOperatorEnumEEnum, ComparisonOperatorEnum.LESS_OR_EQUAL);
		addEEnumLiteral(comparisonOperatorEnumEEnum, ComparisonOperatorEnum.EQUAL);
		addEEnumLiteral(comparisonOperatorEnumEEnum, ComparisonOperatorEnum.GREATER_OR_EQUAL);
		addEEnumLiteral(comparisonOperatorEnumEEnum, ComparisonOperatorEnum.GREATER);

		initEEnum(locationOperatorEnumEEnum, LocationOperatorEnum.class, "LocationOperatorEnum");
		addEEnumLiteral(locationOperatorEnumEEnum, LocationOperatorEnum.ALLOCATION);
		addEEnumLiteral(locationOperatorEnumEEnum, LocationOperatorEnum.DISLOCATION);

		initEEnum(optimizationDirectionEnumEEnum, OptimizationDirectionEnum.class, "OptimizationDirectionEnum");
		addEEnumLiteral(optimizationDirectionEnumEEnum, OptimizationDirectionEnum.MIN);
		addEEnumLiteral(optimizationDirectionEnumEEnum, OptimizationDirectionEnum.MAX);

		initEEnum(quantifierEnumEEnum, QuantifierEnum.class, "QuantifierEnum");
		addEEnumLiteral(quantifierEnumEEnum, QuantifierEnum.FOR_ALL);
		addEEnumLiteral(quantifierEnumEEnum, QuantifierEnum.EXIST);
		addEEnumLiteral(quantifierEnumEEnum, QuantifierEnum.ANY);
	}

} //OperatorsPackageImpl
