/**
 */
package org.fortiss.af3.exploration.moea.model.predefined.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.ETypeParameter;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.fortiss.af3.component.model.AF3ComponentPackage;

import org.fortiss.af3.exploration.dsl.model.ModelPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.ExpressionsPackage;

import org.fortiss.af3.exploration.dsl.model.operators.OperatorsPackage;

import org.fortiss.af3.exploration.dsl.model.patterns.PatternsPackage;

import org.fortiss.af3.exploration.model.CommonPackage;
import org.fortiss.af3.exploration.model.DimensionsPackage;
import org.fortiss.af3.exploration.model.ExplorationPackage;

import org.fortiss.af3.exploration.model.location.LocationPackage;

import org.fortiss.af3.exploration.moea.model.MoeaPackage;

import org.fortiss.af3.exploration.moea.model.feature.FeaturePackage;

import org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl;

import org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl;

import org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage;

import org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl;

import org.fortiss.af3.exploration.moea.model.predefined.ComponentMultiAllocationConstraint;
import org.fortiss.af3.exploration.moea.model.predefined.ComponentMultiDislocationConstraint;
import org.fortiss.af3.exploration.moea.model.predefined.EnergyMinObjective;
import org.fortiss.af3.exploration.moea.model.predefined.FailureMinObjective;
import org.fortiss.af3.exploration.moea.model.predefined.FailureMode;
import org.fortiss.af3.exploration.moea.model.predefined.FailureType;
import org.fortiss.af3.exploration.moea.model.predefined.MultiLocationConstraint;
import org.fortiss.af3.exploration.moea.model.predefined.PredefinedFactory;
import org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage;
import org.fortiss.af3.exploration.moea.model.predefined.ReliabilityAnalysis;
import org.fortiss.af3.exploration.moea.model.predefined.SafetyComparison;
import org.fortiss.af3.exploration.moea.model.predefined.SafetyIntegrityLevelConstraint;

import org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage;

import org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl;

import org.fortiss.af3.platform.model.AF3PlatformPackage;

import org.fortiss.af3.safety.model.SafetyPackage;

import org.fortiss.tooling.base.model.element.ElementPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PredefinedPackageImpl extends EPackageImpl implements PredefinedPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass failureMinObjectiveEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass reliabilityAnalysisEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass energyMinObjectiveEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass multiLocationConstraintEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass componentMultiAllocationConstraintEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass componentMultiDislocationConstraintEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass safetyIntegrityLevelConstraintEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass safetyComparisonEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum failureModeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum failureTypeEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private PredefinedPackageImpl() {
		super(eNS_URI, PredefinedFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link PredefinedPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static PredefinedPackage init() {
		if (isInited) return (PredefinedPackage)EPackage.Registry.INSTANCE.getEPackage(PredefinedPackage.eNS_URI);

		// Obtain or create and register package
		PredefinedPackageImpl thePredefinedPackage = (PredefinedPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof PredefinedPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new PredefinedPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		CommonPackage.eINSTANCE.eClass();
		DimensionsPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		MoeaPackageImpl theMoeaPackage = (MoeaPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(MoeaPackage.eNS_URI) instanceof MoeaPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(MoeaPackage.eNS_URI) : MoeaPackage.eINSTANCE);
		FeaturePackageImpl theFeaturePackage = (FeaturePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FeaturePackage.eNS_URI) instanceof FeaturePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FeaturePackage.eNS_URI) : FeaturePackage.eINSTANCE);
		ParametersPackageImpl theParametersPackage = (ParametersPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ParametersPackage.eNS_URI) instanceof ParametersPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ParametersPackage.eNS_URI) : ParametersPackage.eINSTANCE);
		SolutionsPackageImpl theSolutionsPackage = (SolutionsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SolutionsPackage.eNS_URI) instanceof SolutionsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SolutionsPackage.eNS_URI) : SolutionsPackage.eINSTANCE);

		// Create package meta-data objects
		thePredefinedPackage.createPackageContents();
		theMoeaPackage.createPackageContents();
		theFeaturePackage.createPackageContents();
		theParametersPackage.createPackageContents();
		theSolutionsPackage.createPackageContents();

		// Initialize created meta-data
		thePredefinedPackage.initializePackageContents();
		theMoeaPackage.initializePackageContents();
		theFeaturePackage.initializePackageContents();
		theParametersPackage.initializePackageContents();
		theSolutionsPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		thePredefinedPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(PredefinedPackage.eNS_URI, thePredefinedPackage);
		return thePredefinedPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFailureMinObjective() {
		return failureMinObjectiveEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFailureMinObjective_Mode() {
		return (EAttribute)failureMinObjectiveEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFailureMinObjective_Type() {
		return (EAttribute)failureMinObjectiveEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getReliabilityAnalysis() {
		return reliabilityAnalysisEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEnergyMinObjective() {
		return energyMinObjectiveEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMultiLocationConstraint() {
		return multiLocationConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMultiLocationConstraint_SingleLocationConstraints() {
		return (EReference)multiLocationConstraintEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComponentMultiAllocationConstraint() {
		return componentMultiAllocationConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComponentMultiDislocationConstraint() {
		return componentMultiDislocationConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSafetyIntegrityLevelConstraint() {
		return safetyIntegrityLevelConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSafetyIntegrityLevelConstraint_Components() {
		return (EReference)safetyIntegrityLevelConstraintEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSafetyComparison() {
		return safetyComparisonEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getFailureMode() {
		return failureModeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getFailureType() {
		return failureTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredefinedFactory getPredefinedFactory() {
		return (PredefinedFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		failureMinObjectiveEClass = createEClass(FAILURE_MIN_OBJECTIVE);
		createEAttribute(failureMinObjectiveEClass, FAILURE_MIN_OBJECTIVE__MODE);
		createEAttribute(failureMinObjectiveEClass, FAILURE_MIN_OBJECTIVE__TYPE);

		reliabilityAnalysisEClass = createEClass(RELIABILITY_ANALYSIS);

		energyMinObjectiveEClass = createEClass(ENERGY_MIN_OBJECTIVE);

		multiLocationConstraintEClass = createEClass(MULTI_LOCATION_CONSTRAINT);
		createEReference(multiLocationConstraintEClass, MULTI_LOCATION_CONSTRAINT__SINGLE_LOCATION_CONSTRAINTS);

		componentMultiAllocationConstraintEClass = createEClass(COMPONENT_MULTI_ALLOCATION_CONSTRAINT);

		componentMultiDislocationConstraintEClass = createEClass(COMPONENT_MULTI_DISLOCATION_CONSTRAINT);

		safetyIntegrityLevelConstraintEClass = createEClass(SAFETY_INTEGRITY_LEVEL_CONSTRAINT);
		createEReference(safetyIntegrityLevelConstraintEClass, SAFETY_INTEGRITY_LEVEL_CONSTRAINT__COMPONENTS);

		safetyComparisonEClass = createEClass(SAFETY_COMPARISON);

		// Create enums
		failureModeEEnum = createEEnum(FAILURE_MODE);
		failureTypeEEnum = createEEnum(FAILURE_TYPE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		DimensionsPackage theDimensionsPackage = (DimensionsPackage)EPackage.Registry.INSTANCE.getEPackage(DimensionsPackage.eNS_URI);
		ModelPackage theModelPackage = (ModelPackage)EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI);
		CommonPackage theCommonPackage = (CommonPackage)EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI);
		AF3ComponentPackage theAF3ComponentPackage = (AF3ComponentPackage)EPackage.Registry.INSTANCE.getEPackage(AF3ComponentPackage.eNS_URI);
		ExpressionsPackage theExpressionsPackage = (ExpressionsPackage)EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI);
		ElementPackage theElementPackage = (ElementPackage)EPackage.Registry.INSTANCE.getEPackage(ElementPackage.eNS_URI);
		LocationPackage theLocationPackage = (LocationPackage)EPackage.Registry.INSTANCE.getEPackage(LocationPackage.eNS_URI);
		AF3PlatformPackage theAF3PlatformPackage = (AF3PlatformPackage)EPackage.Registry.INSTANCE.getEPackage(AF3PlatformPackage.eNS_URI);
		ExplorationPackage theExplorationPackage = (ExplorationPackage)EPackage.Registry.INSTANCE.getEPackage(ExplorationPackage.eNS_URI);
		SafetyPackage theSafetyPackage = (SafetyPackage)EPackage.Registry.INSTANCE.getEPackage(SafetyPackage.eNS_URI);
		OperatorsPackage theOperatorsPackage = (OperatorsPackage)EPackage.Registry.INSTANCE.getEPackage(OperatorsPackage.eNS_URI);
		PatternsPackage thePatternsPackage = (PatternsPackage)EPackage.Registry.INSTANCE.getEPackage(PatternsPackage.eNS_URI);

		// Create type parameters
		ETypeParameter multiLocationConstraintEClass_LHT = addETypeParameter(multiLocationConstraintEClass, "LHT");
		ETypeParameter multiLocationConstraintEClass_RHT = addETypeParameter(multiLocationConstraintEClass, "RHT");
		ETypeParameter safetyComparisonEClass_T = addETypeParameter(safetyComparisonEClass, "T");

		// Set bounds for type parameters
		EGenericType g1 = createEGenericType(theElementPackage.getIModelElement());
		multiLocationConstraintEClass_LHT.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		multiLocationConstraintEClass_RHT.getEBounds().add(g1);

		// Add supertypes to classes
		g1 = createEGenericType(theDimensionsPackage.getResourceDimension());
		failureMinObjectiveEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theModelPackage.getMOEAExplorationExpression());
		failureMinObjectiveEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theCommonPackage.getMOExplorationObjective());
		EGenericType g2 = createEGenericType(ecorePackage.getEDoubleObject());
		g1.getETypeArguments().add(g2);
		failureMinObjectiveEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g2 = createEGenericType(ecorePackage.getEDoubleObject());
		g1.getETypeArguments().add(g2);
		reliabilityAnalysisEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getElementExpression());
		g2 = createEGenericType(theAF3ComponentPackage.getComponent());
		g1.getETypeArguments().add(g2);
		reliabilityAnalysisEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theModelPackage.getMOEAExplorationExpression());
		reliabilityAnalysisEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theCommonPackage.getMOExplorationObjective());
		g2 = createEGenericType(ecorePackage.getEDoubleObject());
		g1.getETypeArguments().add(g2);
		energyMinObjectiveEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theDimensionsPackage.getEnergyDimension());
		energyMinObjectiveEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theModelPackage.getMOEAExplorationExpression());
		energyMinObjectiveEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theLocationPackage.getLocationConstraint());
		g2 = createEGenericType(multiLocationConstraintEClass_LHT);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(multiLocationConstraintEClass_RHT);
		g1.getETypeArguments().add(g2);
		multiLocationConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getMultiLocationConstraint());
		g2 = createEGenericType(theAF3ComponentPackage.getComponent());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g1.getETypeArguments().add(g2);
		componentMultiAllocationConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExplorationPackage.getExplorationConstraint());
		g2 = createEGenericType(ecorePackage.getEBooleanObject());
		g1.getETypeArguments().add(g2);
		componentMultiAllocationConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getMultiLocationConstraint());
		g2 = createEGenericType(theAF3ComponentPackage.getComponent());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g1.getETypeArguments().add(g2);
		componentMultiDislocationConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExplorationPackage.getExplorationConstraint());
		g2 = createEGenericType(ecorePackage.getEBooleanObject());
		g1.getETypeArguments().add(g2);
		componentMultiDislocationConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExplorationPackage.getExplorationConstraint());
		g2 = createEGenericType(theSafetyPackage.getSIL());
		g1.getETypeArguments().add(g2);
		safetyIntegrityLevelConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theDimensionsPackage.getSafetyDimension());
		safetyIntegrityLevelConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theModelPackage.getMOEAExplorationExpression());
		safetyIntegrityLevelConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theOperatorsPackage.getComparisonOp());
		g2 = createEGenericType(safetyComparisonEClass_T);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(thePatternsPackage.getElementProperty());
		g1.getETypeArguments().add(g2);
		EGenericType g3 = createEGenericType(theAF3ComponentPackage.getComponent());
		g2.getETypeArguments().add(g3);
		g3 = createEGenericType(safetyComparisonEClass_T);
		g2.getETypeArguments().add(g3);
		g2 = createEGenericType(thePatternsPackage.getElementProperty());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g2.getETypeArguments().add(g3);
		g3 = createEGenericType(safetyComparisonEClass_T);
		g2.getETypeArguments().add(g3);
		safetyComparisonEClass.getEGenericSuperTypes().add(g1);

		// Initialize classes and features; add operations and parameters
		initEClass(failureMinObjectiveEClass, FailureMinObjective.class, "FailureMinObjective", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFailureMinObjective_Mode(), this.getFailureMode(), "mode", "FailSafe", 1, 1, FailureMinObjective.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFailureMinObjective_Type(), this.getFailureType(), "type", null, 1, 1, FailureMinObjective.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		addEOperation(failureMinObjectiveEClass, theAF3ComponentPackage.getComponent(), "getTargetComponent", 1, 1, IS_UNIQUE, IS_ORDERED);

		EOperation op = addEOperation(failureMinObjectiveEClass, null, "setTargetComponent", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theAF3ComponentPackage.getComponent(), "targetComponent", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(reliabilityAnalysisEClass, ReliabilityAnalysis.class, "ReliabilityAnalysis", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(energyMinObjectiveEClass, EnergyMinObjective.class, "EnergyMinObjective", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(multiLocationConstraintEClass, MultiLocationConstraint.class, "MultiLocationConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(theLocationPackage.getLocationConstraint());
		g2 = createEGenericType(multiLocationConstraintEClass_LHT);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(multiLocationConstraintEClass_RHT);
		g1.getETypeArguments().add(g2);
		initEReference(getMultiLocationConstraint_SingleLocationConstraints(), g1, null, "singleLocationConstraints", null, 1, -1, MultiLocationConstraint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(multiLocationConstraintEClass, null, "getLeftMultiLocationModelElement", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(multiLocationConstraintEClass_LHT);
		initEOperation(op, g1);

		op = addEOperation(multiLocationConstraintEClass, null, "getAllRightMultiLocationModelElements", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEEList());
		g2 = createEGenericType(multiLocationConstraintEClass_RHT);
		g1.getETypeArguments().add(g2);
		initEOperation(op, g1);

		initEClass(componentMultiAllocationConstraintEClass, ComponentMultiAllocationConstraint.class, "ComponentMultiAllocationConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(componentMultiAllocationConstraintEClass, null, "setComponentMultiAllocations", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theAF3ComponentPackage.getComponent(), "comp", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEEList());
		g2 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "execUnits", 1, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(componentMultiAllocationConstraintEClass, theAF3ComponentPackage.getComponent(), "getComponent", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(componentMultiAllocationConstraintEClass, null, "getExecutionUnits", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEEList());
		g2 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g1.getETypeArguments().add(g2);
		initEOperation(op, g1);

		initEClass(componentMultiDislocationConstraintEClass, ComponentMultiDislocationConstraint.class, "ComponentMultiDislocationConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(componentMultiDislocationConstraintEClass, null, "setComponentMultiDislocations", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theAF3ComponentPackage.getComponent(), "comp", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEEList());
		g2 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "execUnits", 1, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(componentMultiDislocationConstraintEClass, theAF3ComponentPackage.getComponent(), "getComponent", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(componentMultiDislocationConstraintEClass, null, "getExecutionUnits", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEEList());
		g2 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g1.getETypeArguments().add(g2);
		initEOperation(op, g1);

		initEClass(safetyIntegrityLevelConstraintEClass, SafetyIntegrityLevelConstraint.class, "SafetyIntegrityLevelConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSafetyIntegrityLevelConstraint_Components(), theAF3ComponentPackage.getComponent(), null, "components", null, 1, -1, SafetyIntegrityLevelConstraint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(safetyIntegrityLevelConstraintEClass, null, "getLimitation", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEEList());
		g2 = createEGenericType(theSafetyPackage.getSIL());
		g1.getETypeArguments().add(g2);
		initEOperation(op, g1);

		initEClass(safetyComparisonEClass, SafetyComparison.class, "SafetyComparison", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Initialize enums and add enum literals
		initEEnum(failureModeEEnum, FailureMode.class, "FailureMode");
		addEEnumLiteral(failureModeEEnum, FailureMode.FAIL_SAFE);
		addEEnumLiteral(failureModeEEnum, FailureMode.FAIL_OPERATIONAL);

		initEEnum(failureTypeEEnum, FailureType.class, "FailureType");
		addEEnumLiteral(failureTypeEEnum, FailureType.DUF);
		addEEnumLiteral(failureTypeEEnum, FailureType.SDC);
		addEEnumLiteral(failureTypeEEnum, FailureType.ALL);
	}

} //PredefinedPackageImpl
