/*--------------------------------------------------------------------------+
$Id: Phenotype.java 3382 2016-08-08 15:26:54Z diewald $
|                                                                          |
| Copyright 2015 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.phenotype;

import org.fortiss.af3.exploration.alg.service.IExplorationEncoding;

/**
 * Interface for phenotypes (not present any more in Opt4J).
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3382 $
 * @ConQAT.Rating YELLOW Hash: CDE7DC203CF0D61FE90C2F6862294319
 */
public interface Phenotype extends IExplorationEncoding {
	// Marker interface.
}
